(* filtert ne liste nach abflugsorten, d.h. wenn das shuttle auf der erde ist,
werden alle passagiere auf erde2 rausgefiltert *)
fun FilterList ([], Abflug :
Abflugort) = [] |     FilterList (PInput : PassagierListe, Abflug : Abflugort)
=	      if (#Ort (hd PInput)) = Abflug
         then [hd PInput]@FilterList (tl PInput, Abflug)
         else FilterList(tl PInput, Abflug);

(* ??? *)
fun NotOrt Erde  = Erde2 | 
    NotOrt Erde2 = Erde; 


(* sucht den eintrag mit der hoechsten prioritaet aus der liste *)
fun FindBestEntry( [], FEntry : TreeEntry, StartValue:int ) = FEntry |
    FindBestEntry( FEntries : TreeEntry list, FEntry : TreeEntry,
                   StartValue:int) =        
    if #SumPrio (hd FEntries) > StartValue     
    then FindBestEntry(tl FEntries,hd FEntries,#SumPrio (hd FEntries))
    else FindBestEntry(tl FEntries,FEntry,StartValue);    


(* ist x ein element der liste *)
fun IsElement ( Liste : PassagierListe, Element : PassagierType) = 
    if Liste = []
    then false
    else if hd Liste = Element
         then true
         else IsElement ( tl Liste, Element );    
 

(* holt das element an index. stelle *)
fun GetElement ( [] : PassagierListe, Index ) = {Nummer=0, Prio=0, Gewicht=0,
                                                 Ort= Erde} |     
    GetElement (Liste : PassagierListe, Index ) =      
    if Index = 1
    then hd Liste 
    else GetElement ( tl Liste, Index-1 );


(* subtrahiert liste 2 von liste 1 *)
fun SubList ( List1, [] : PassagierListe ) = List1 |
    SubList ( [], List2 : PassagierListe ) = [] |
    SubList ( List1, List2 : PassagierListe ) = 
    if IsElement ( List2, hd List1 ) = false
    then [hd List1]@SubList ( tl List1, List2 )
    else SubList ( tl List1, List2 );


(* anhand der indizies wird eine passagierliste erstellt *)
fun GetPassagierList ( [] : int list, PListe : PassagierListe ) = [] |
    GetPassagierList ( Liste : int list, PListe : PassagierListe ) =
    [GetElement ( PListe, hd Liste )]@GetPassagierList ( tl Liste, PListe );
    

(* erhoeht die prioritaet fuer die wartenden *)
fun IncPrio ( [] : PassagierListe ) = [] |
    IncPrio ( Liste : PassagierListe ) =
    [{Nummer = #Nummer (hd Liste), Ort = #Ort (hd Liste), 
      Gewicht = #Gewicht (hd Liste), Prio = #Prio (hd Liste)+1}]@
    IncPrio( tl Liste );


(* die hauptproc *)
fun LoadShuttle (LInput : PassagierListe) : PassagierListe*PassagierListe = 
let
 val LNoFly    = FilterList ( LInput, NotOrt (#Ort Shuttle));
 val LFly      = FilterList ( LInput, #Ort Shuttle);
 val PrioTree  = BuildTree ( LFly, {SumGewicht = 0,SumPrio = 0} );
 val Entries   = Leafs2List ( PrioTree );
 val BestEntry = FindBestEntry ( Entries, {SumGewicht=0, SumPrio=0}, 0 );
 val LFlyL     = GetFlyerList ( BestEntry, PrioTree, [], 1, false );
 val LFlyP     = GetPassagierList ( LFlyL, LFly );
 val LNoFly2   = SubList ( LFly, LFlyP );
 val LNoFly    = LNoFly@IncPrio( LNoFly2 );
in

 (LFlyP, LNoFly)
 
end;
