(* Baut einen binaeren Baum auf. Die Knoten enthalten jeweils die Summe der
   Gewichte und Prioritaeten von allen Passagieren bis zu diesem Knoten. Die
   Blaetter enthalten demnach alle Kombinationen von Gewichten und Prioritaeten
*)

fun BuildTree(BInput:PassagierListe,Entry:TreeEntry):BinTree  = 
 if BInput<> []
  then
   node(
            (* summen weiterreichen *)
         {SumGewicht=(#SumGewicht Entry + #Gewicht (hd BInput)), 
          SumPrio=(#SumPrio Entry + #Prio (hd BInput))},
            (* linker sohn: fliegt mit *) 
         BuildTree(tl BInput,
                   {SumGewicht=(#SumGewicht Entry + #Gewicht (hd BInput)),
                    SumPrio=(#SumPrio Entry + #Prio (hd BInput))}),
            (* rechter sohn: fliegt nicht mit *)   
         BuildTree(tl BInput,Entry)
       )
                 
  else node(Entry,empty,empty);


(* hier werden alle Blaetter in eine Liste geschrieben *)

fun Leafs2List empty = []
  | Leafs2List (node(e,empty,empty)) =
      if #SumGewicht e <= #Kapazitaet Shuttle then [e] else []
  | Leafs2List(node(e,sohn1,sohn2)) = Leafs2List(sohn1)@Leafs2List(sohn2);



(* der Baum wird solange durchsucht, bis er an einem Blatt angekommen ist, der
gleich einem gewuenschten Blatt (im Hauptprogramm dann das Blatt mit der
optimalen Gewicht/Prioritaets-Kombination) ist. Dann werden alle
Passagier-Nummern, aus dem Baum in eine Liste gegeben, die daran beteiligt
waren*)

fun GetFlyerList(WhichCombi:TreeEntry,
                node(e:TreeEntry,sohn1:BinTree,sohn2:BinTree):BinTree,        
                actList:int list,
                height:int,                
                found:bool)              :int list =
if found=false then
 if (sohn1=empty) andalso (sohn2=empty) then
      if e = WhichCombi
      then  
       GetFlyerList(WhichCombi,node(e,sohn1,sohn2),actList,height,true)
      else[]
  else  GetFlyerList(WhichCombi,sohn1,[height]@actList,height+1,false)@ 
        GetFlyerList(WhichCombi,sohn2,actList,height+1,false)

 else actList;

